--- a/lib/ldb/wscript
+++ b/lib/ldb/wscript
@@ -519,10 +519,6 @@
                          install=False)
 
         bld.SAMBA_BINARY('ldb_key_value_sub_txn_tdb_test',
-                         bld.SUBDIR('ldb_key_value',
-                             '''ldb_kv_search.c
-                                ldb_kv_index.c
-                                ldb_kv_cache.c''') +
                          'tests/ldb_key_value_sub_txn_test.c',
                          cflags='-DTEST_BE=\"tdb\"',
                          deps='cmocka ldb ldb_tdb_err_map',
--- a/source4/heimdal_build/wscript_build
+++ b/source4/heimdal_build/wscript_build
@@ -5,6 +5,7 @@
 from samba_utils import SET_TARGET_TYPE
 from samba_autoconf import CURRENT_CFLAGS
 from samba_utils import LOAD_ENVIRONMENT, TO_LIST
+from samba_bundled import BUILTIN_LIBRARY
 
 def heimdal_path(p, absolute=False):
     hpath = os.path.join("../heimdal", p)
@@ -215,7 +216,10 @@
 def HEIMDAL_LIBRARY(libname, source, deps, vnum, version_script, includes='', cflags=[]):
     '''define a Heimdal library'''
 
-    obj_target = libname + '.objlist'
+    if BUILTIN_LIBRARY(bld, libname):
+        obj_target = libname
+    else:
+        obj_target = libname + '.objlist'
 
     # first create a target for building the object files for this library
     # by separating in this way, we avoid recompiling the C files
@@ -227,6 +231,9 @@
                         cflags         = cflags,
                         group          = 'main')
 
+    if BUILTIN_LIBRARY(bld, libname):
+        return
+
     if not SET_TARGET_TYPE(bld, libname, "LIBRARY"):
         return
 
